/****************************************************************************
 *
 * Copyright (c) 2010-2012, EBM WebSourcing
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA 
 *
 *****************************************************************************/
 
package org.ow2.petals.develpment.enforcer.rules;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.apache.maven.project.MavenProject;

public final class SvnUtil {

    private SvnUtil() {
    }
    
    public static final String grepScmConnectionFromSvnEntries(MavenProject project) {
        File basedir = project.getBasedir();
        File svnDir = new File(basedir, ".svn");
        File svnEntriesFile = new File(svnDir, "entries");
        if ((!svnEntriesFile.exists()) || (!svnEntriesFile.canRead())) {
            return null;
        }

        String svnPath = grepSvnPathFromEntries(svnEntriesFile);
        if (svnPath == null)
            return null;
        return "scm:svn:" + svnPath;
    }

    

    private static final String grepSvnPathFromEntries(File svnEntriesFile) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(svnEntriesFile));
            String svnPath = null;
            String line = null;
            while ((line = br.readLine()) != null) {
                if (line.startsWith("https://") || (line.startsWith("svn://"))) {
                    svnPath = line;
                    break;
                }
            }
            return svnPath;
        } catch (final FileNotFoundException e) {
            return null;
        } catch (final IOException e) {
            return null;
        }
    }    
}
